

local WoWPro = WoWPro
local L = WoWPro.Locale
local GAP = 8
local tekcheck = LibStub("tekKonfig-Checkbox")
local tekbutton = LibStub("tekKonfig-Button")


local frame = CreateFrame("Frame", nil, InterfaceOptionsFramePanelContainer)
WoWPro.configpanel = frame
frame.name = "WoW-Pro"
frame:Hide()
frame:SetScript("OnShow", function()
	local title, subtitle = LibStub("tekKonfig-Heading").new(frame, "WoW-Pro", L["These settings are saved on a per-char basis."])

	local qtrack = tekcheck.new(frame, nil, L["Automatically track quests"], "TOPLEFT", subtitle, "BOTTOMLEFT", -2, -GAP)
	qtrack.tiptext = L["Automatically toggle the default quest tracker for current 'complete quest' objectives."]
	local checksound = qtrack:GetScript("OnClick")
	qtrack:SetScript("OnClick", function(self) checksound(self); WoWPro.db.char.trackquests = not WoWPro.db.char.trackquests end)
	qtrack:SetChecked(WoWPro.db.char.trackquests)


	local showstatusframe = tekcheck.new(frame, nil, L["Show status frame"], "TOPLEFT", qtrack, "BOTTOMLEFT", 0, -GAP)
	showstatusframe.tiptext = L["Display the status frame with current quest objective."]
	showstatusframe:SetScript("OnClick", function(self) checksound(self); WoWPro.db.char.showstatusframe = not WoWPro.db.char.showstatusframe; WoWPro:PositionStatusFrame() end)
	showstatusframe:SetChecked(WoWPro.db.char.showstatusframe)

	local resetpos = tekbutton.new_small(frame, "TOP", showstatusframe, "CENTER", 0, 11)
	resetpos:SetPoint("RIGHT", -16, 0)
	resetpos:SetText(L["Reset"])
	resetpos.tiptext = L["Reset the status frame to the default position"]
	resetpos:SetScript("OnClick", function(self)
		WoWPro.db.profile.statusframepoint, WoWPro.db.profile.statusframex, WoWPro.db.profile.statusframey = nil
		WoWPro:PositionStatusFrame()
	end)


	local showuseitem = tekcheck.new(frame, nil, L["Show item button"], "TOPLEFT", showstatusframe, "BOTTOMLEFT", 0, -GAP)
	showuseitem.tiptext = L["Display a button when you must use an item to start or complete a quest."]
	showuseitem:SetChecked(WoWPro.db.char.showuseitem)

	local resetpos2 = tekbutton.new_small(frame, "TOP", showuseitem, "CENTER", 0, 11)
	resetpos2:SetPoint("RIGHT", -16, 0)
	resetpos2:SetText(L["Reset"])
	resetpos2.tiptext = L["Reset the item button to the default position"]
	resetpos2:SetScript("OnClick", function(self)
		WoWPro.db.profile.itemframepoint, WoWPro.db.profile.itemframex, WoWPro.db.profile.itemframey = nil
		WoWPro:PositionItemFrame()
	end)

	local showuseitemcomplete, showuseitemcompletelabel = tekcheck.new(frame, nil, L["Show buttom for 'complete' objectives"], "TOPLEFT", showuseitem, "BOTTOMLEFT", GAP*2, -GAP)
	showuseitemcomplete.tiptext = L["The advanced quest tracker in the default UI will show these items.  Enable this if you would rather have WoW-Pro's button."]
	showuseitemcomplete:SetScript("OnClick", function(self) checksound(self); WoWPro.db.char.showuseitemcomplete = not WoWPro.db.char.showuseitemcomplete; WoWPro:UpdateStatusFrame() end)
	showuseitemcomplete:SetChecked(WoWPro.db.char.showuseitemcomplete)
	if WoWPro.db.char.showuseitem then
		showuseitemcomplete:Enable()
		showuseitemcompletelabel:SetFontObject(GameFontHighlight)
	else
		showuseitemcomplete:Disable()
		showuseitemcompletelabel:SetFontObject(GameFontDisable)
	end

	showuseitem:SetScript("OnClick", function(self)
		checksound(self)
		WoWPro.db.char.showuseitem = not WoWPro.db.char.showuseitem
		WoWPro:UpdateStatusFrame()
		if WoWPro.db.char.showuseitem then
			showuseitemcomplete:Enable()
			showuseitemcompletelabel:SetFontObject(GameFontHighlight)
		else
			showuseitemcomplete:Disable()
			showuseitemcompletelabel:SetFontObject(GameFontDisable)
		end
	end)


	local mapnotecoords = tekcheck.new(frame, nil, L["Map note coords"], "TOPLEFT", showuseitemcomplete, "BOTTOMLEFT", -GAP*2, -GAP)
	mapnotecoords.tiptext = L["Map coordinates found in tooltip notes (requires TomTom)."]
	mapnotecoords:SetScript("OnClick", function(self) checksound(self); WoWPro.db.char.mapnotecoords = not WoWPro.db.char.mapnotecoords end)
	mapnotecoords:SetChecked(WoWPro.db.char.mapnotecoords)

	local mapquestgivers = tekcheck.new(frame, nil, L["Automatically map questgivers"], "TOPLEFT", mapnotecoords, "BOTTOMLEFT", 0, -GAP)
	mapquestgivers.tiptext = L["Automatically map questgivers for accept and turnin objectives (requires LightHeaded and TomTom)."]
	mapquestgivers:SetChecked(WoWPro.db.char.mapquestgivers)

	local mapquestgivernotes, mapquestgivernoteslabel = tekcheck.new(frame, nil, L["Always map coords from notes"], "TOPLEFT", mapquestgivers, "BOTTOMLEFT", GAP*2, -GAP)
	mapquestgivernotes.tiptext = L["Map note coords even when LightHeaded provides coords."]
	mapquestgivernotes:SetScript("OnClick", function(self) checksound(self); WoWPro.db.char.alwaysmapnotecoords = not WoWPro.db.char.alwaysmapnotecoords end)
	mapquestgivernotes:SetChecked(WoWPro.db.char.alwaysmapnotecoords)
	if WoWPro.db.char.mapquestgivers then
		mapquestgivernotes:Enable()
		mapquestgivernoteslabel:SetFontObject(GameFontHighlight)
	else
		mapquestgivernotes:Disable()
		mapquestgivernoteslabel:SetFontObject(GameFontDisable)
	end

	mapquestgivers:SetScript("OnClick", function(self)
		checksound(self)
		WoWPro.db.char.mapquestgivers = not WoWPro.db.char.mapquestgivers
		if WoWPro.db.char.mapquestgivers then
			mapquestgivernotes:Enable()
			mapquestgivernoteslabel:SetFontObject(GameFontHighlight)
		else
			mapquestgivernotes:Disable()
			mapquestgivernoteslabel:SetFontObject(GameFontDisable)
		end
	end)

	frame:SetScript("OnShow", nil)
end)

InterfaceOptions_AddCategory(frame)


----------------------------
--      LDB Launcher      --
----------------------------

local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local dataobj = ldb:GetDataObjectByName("WoWProLauncher") or ldb:NewDataObject("WoWProLauncher", {type = "launcher", icon = "Interface\\Icons\\Ability_Hunter_Pathfinding", tocname = "WoWPro"})
dataobj.OnClick = function() InterfaceOptionsFrame_OpenToCategory(frame) end
