
local L = WoWPro.Locale

local zonei, zonec, zonenames = {}, {}, {}
for ci,c in pairs{GetMapContinents()} do
	zonenames[ci] = {GetMapZones(ci)}
	for zi,z in pairs(zonenames[ci]) do
		zonei[z], zonec[z] = zi, ci
	end
end


local cache = {}
local function MapPoint(zone, x, y, desc, c, z)
	WoWPro:DebugF(1, "Mapping %q - %s (%.2f, %.2f)", desc, zone or z, x, y)
	local zi, zc = z or zone and zonei[zone], c or zone and zonec[zone]
	if not zi then
		if zone then WoWPro:PrintF(L["Cannot find zone %q, using current zone."], zone)
		else WoWPro:Print(L["No zone provided, using current zone."]) end

		zi, zc = GetCurrentMapZone(), GetCurrentMapContinent()
	end
	zone = zone or zonenames[zc][zi]

	if TomTom then table.insert(cache, TomTom:AddZWaypoint(zc, zi, x, y, desc, false))
	elseif Cartographer_Waypoints then
		local pt = NotePoint:new(zone, x/100, y/100, desc)
		Cartographer_Waypoints:AddWaypoint(pt)
		table.insert(cache, pt.WaypointID)
	end
end


local elapsed, taction, tquest, tzone, tnote, tqid, tlogi
local f = CreateFrame("Frame")
f:Hide()
f:SetScript("OnShow", function() elapsed = 0 end)
f:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < 1 then return end
	self:Hide()
	WoWPro:ParseAndMapCoords(taction, tquest, tzone, tnote, tqid, tlogi)
end)
local temp = {}
function WoWPro:ParseAndMapCoords(action, quest, zone, note, qid, logi)
	taction, tquest, tzone, tnote, tqid, tlogi = action, quest, zone, note, qid, logi
	if TomTom and TomTom.RemoveWaypoint then
		while cache[1] do TomTom:RemoveWaypoint(table.remove(cache)) end
	elseif Cartographer_Waypoints then
		while cache[1] do Cartographer_Waypoints:CancelWaypoint(table.remove(cache)) end
	end
--logi and 
	local questtext = self:GetObjectiveTag("QO")
	local nopoi = self:GetObjectiveTag("NOPOI")
	WoWPro:Debug(10,"ParseAndMapCoords", nopoi, action, logi, questtext)
	if (not nopoi and action == "COMPLETE" or action == "TURNIN" or questtext) then
		QuestMapUpdateAllQuests()
		QuestPOIUpdateIcons()
		local _, x, y, obj = QuestPOIGetIconInfo(qid)
		if x and y then table.insert(temp, y*100) table.insert(temp, x*100)
		else return f:Show() end
--		MapPoint(zone, (x*100), (y*100), quest)
	end
--or action == "TURNIN"
	if not temp[1] and (action == "ACCEPT") and LightHeaded then self:MapLightHeadedNPC(qid, action, quest) end
	if not temp[1] and note and self.db.char.mapnotecoords then for x,y in note:gmatch(L.COORD_MATCH) do table.insert(temp, tonumber(y)); table.insert(temp, tonumber(x)) end end
	while temp[1] do MapPoint(zone, table.remove(temp), table.remove(temp), questtext or quest) end
--	do local MapPoint(zone, (x*100), (y*100), quest) end
end
-- 

function WoWPro:MapLightHeadedNPC(qid, action, quest)
	if not self.db.char.mapquestgivers then return end

	local npcid, npcname, stype
	if action == "ACCEPT" then _, _, _, _, stype, npcname, npcid = LightHeaded:GetQuestInfo(qid)
	else _, _, _, _, _, _, _, stype, npcname, npcid = LightHeaded:GetQuestInfo(qid) end
	self:Debug(1, "LightHeaded lookup", action, qid, stype, npcname, npcid)
	if stype ~= "npc" then return end

	local data = LightHeaded:LoadNPCData(tonumber(npcid))
	if not data then return end
	for zid,x,y in data:gmatch("([^,]+),([^,]+),([^:]+):") do MapPoint(nil, tonumber(x), tonumber(y), quest.." ("..npcname..")", LightHeaded:WZIDToCZ(tonumber(zid))) end
	return true
end